registerForEvent("onUpdate", function()

tp = Game.GetTeleportationFacility()
ts = Game.GetTargetingSystem()
player = Game.GetPlayer()
pPos = player:GetWorldPosition()

-- print(Game.GetTargetingSystem():GetLookAtObject(Game.GetPlayer(), false, false):GetWorldPosition())

local cn = CName.new

function unlockDevice(object, type)
	if object then
	  if type == "Door" then 
		object:OpenDoor() 
	  elseif type == "FakeDoor" then
		object:Dispose()
	  elseif type == "LiftDevice" then
		print('Unlocking Lift')
		object:ActivateDevice()
		object:TurnOnDevice()
		object:StartUsing()
		object:RestorePower()
		object:TurnOnDevice()
		object:TurnAuthorizationModuleOFF()
		object:GetDevicePS():SetDeviceState(1)
	  end
	end 
end

function round(n)
	return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)
end

local allowedDevices = {
	-- Konpeki Tower
    konpekiTowerFrontDoor = { x = -2262, y = 1705, type = 'Door' },
    konpekiTowerSuiteLift = { x = -2229, y = 1771, type = 'LiftDevice' },
	konpekiTowerSuiteShaft = { x = -2228, y = 1769, type = 'FakeDoor' },
	
	-- Gig Penthouse
	gigPenthouseBuildingDoor = { x = -1185, y = 1401, type = 'Door' },
	
	-- Voodoo Chapel Undergroud Base
	voodooUndergroundDoor = {x = -1733, y = -1903, type = 'Door' },
	
	-- Clouds
    cloudsEntranceDoor = {x = -637, y = 806, type = 'Door' },
    cloudsSecretAreaDoor = {x = -648, y = 791, type = 'FakeDoor' },
}


local locations = {
	-- V Mansion
    vMansionIn = { x1 = -1362.7366, y1 = 1262.9171, x2 = -1360.1641, y2 = 1261.3978, ang = { min = 131, max = 214 }, tp = { x = -1340.8207, y = 1189.0009, z = 115.00717, w = 1.0, ang = 355.86430751414 } },
	vMansionOut = { x1 = -1340.0024, y1 = 1188.9678, x2 = -1341.3989, y2 = 1189.8715, ang = { min = 126, max = 175 }, tp = { x = -1361.6105, y = 1261.4937, z = 41.500008, w = 1.0, ang = 354.29516260943 } },
	
	-- Atlantis Bar
    atlantisBarIn = { x1 = -770.48676, y1 = 1106.0305, x2 = -771.2676, y2 = 1103.9075, ang = { min = -121, max = -54 }, tp = { x = -764.93384, y = 1105.6572, z = 29.0, w = 1.0, ang = 277.87610919623 } },
	atlantisBarOut = { x1 = -769.0687, y1 = 1104.3372, x2 = -765.288, y2 = 1106.9291, ang = { min = 75, max = 112 }, tp = { x = -770.46277, y = 1105.0232, z = 29.0, w = 1.0, ang = 95.82663528188 } },
	
	-- Konpeki Tower
    konpekiTowerGateIn = { x1 = -2111.5012, y1 = 1778.6323, x2 = -2115.0469, y2 = 1802.474, ang = { min = 70, max = 153 }, tp = { x = -2126.5457, y = 1789.7084, z = 18.21, w = 1.0, ang = 86.517776489258 } },
    konpekiTowerGateOut = { x1 = -2123.955, y1 = 1797.2015, x2 = -2119.6572, y2 = 1774.1086, ang = { min = -100, max = -27 }, tp = { x = -2109.7732, y = 1787.4629, z = 18.175941, w = 1.0, ang = -58.917133331299 } },
    konpekiTowerSuitOut = { x1 = -2230.854, y1 = 1771.3029, x2 = -2228.2234, y2 = 1771.665, ang = { min = -1, max = 60 }, tp = { x = -2227.602, y = 1768.0632, z = 20.0, w = 1.0, ang = -149.49726867676 } },
}
 
local ang = player:GetWorldYaw()


	local key1 = GetAsyncKeyState(0x46) -- press F
    if key1 ~= space_state then
        space_state = key1
		if space_state then

			for loc, coords in pairs(locations) do

				-- print("Searing For:")
				-- print(loc)
				-- print("------------")

				x = pPos.x
				y = pPos.y
				minx = math.min(coords.x1, coords.x2)
				maxx = math.max(coords.x1, coords.x2)
				miny = math.min(coords.y1, coords.y2)
				maxy = math.max(coords.y1, coords.y2)
        
				intersect = (x >= minx and x <= maxx) and (y >= miny and y <= maxy)
				orientation = (ang > coords.ang.min) and (ang < coords.ang.max)

				if intersect and orientation then
					vTp = Vector4.new(coords.tp.x,coords.tp.y,coords.tp.z,coords.tp.w)
					tp:Teleport(player, vTp , EulerAngles.new(0,0,coords.tp.ang))
					break
				end
			end

			object = ts:GetLookAtObject(player, false, false)
			objCoords = object:GetWorldPosition()

			for device, dCoords in pairs(allowedDevices) do

				match = dCoords.x == round(objCoords.x) and dCoords.y == round(objCoords.y)

				if match then
					print('Device Matched!')
					unlockDevice(object, dCoords.type)
					break;
				end

			end
		end
	end
--
end)






